//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "tedi_main.h"
#include "tedi_ini.h"
#include "tedi_toolbar.h"
#include "tedi_clipboard.h"
#include "tedi_webcolors.h"
#include "tedi_symbol.h"
#include "tedi_goto.h"
#include "tedi_find.h"
#include "tedi_about.h"
#include "tedi_searching.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
AnsiString FileName = "";
EditOptions ed_options;
bool InsertMode = false;
bool IsOpen = false;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 //--------------------------------------------------------------------------
 Form1->ControlStyle = Form1->ControlStyle << csOpaque;
 RichEdit1->ControlStyle = RichEdit1->ControlStyle << csOpaque;
 //--------------------------------------------------------------------------
 ed_options.IniFileRead();
 ed_options.OnCreateForm();
 //--------------------------------------------------------------------------
 mNewExecute(Sender);
 //--------------------------------------------------------------------------
 if(ParamCount()==1) //Command Line
 {
  FileName = LowerCase(ParamStr(1));
  if(FileExists(FileName))
  {
   RichEdit1->Lines->LoadFromFile(FileName);
   Caption = FileName = ExtractFileName(FileName);
   RichEdit1->SelStart = 0;
   RichEdit1->Modified = false;
   IsOpen = true;
   PrintToolBarInformation();
  }
 }
 //--------------------------------------------------------------------------
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1Enter(TObject *Sender)
{
 ed_options.OnEnterRichEdit();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mExitExecute(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mSaveSettingsExecute(TObject *Sender)
{
 ed_options.IniFileCreate();
 ed_options.IniFileWrite();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mToolbarExecute(TObject *Sender)
{
 mToolbar->Checked = !mToolbar->Checked;
 ToolBar1->Visible = mToolbar->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mStatusBarExecute(TObject *Sender)
{
 mStatusBar->Checked = !mStatusBar->Checked;
 StatusBar1->Visible = mStatusBar->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mScrollBarVerticalExecute(TObject *Sender)
{
 mScrollBarVertical->Checked = !mScrollBarVertical->Checked;
 RichEdit1->ScrollBars = (mScrollBarVertical->Checked)? ssVertical : ssNone;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mWordWrapExecute(TObject *Sender)
{
 mWordWrap->Checked = !mWordWrap->Checked;
 RichEdit1->WordWrap = mWordWrap->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mKeepOnTopExecute(TObject *Sender)
{
 mKeepOnTop->Checked = !mKeepOnTop->Checked;
 Form1->FormStyle = (mKeepOnTop->Checked == true)? fsStayOnTop : fsNormal;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mReadOnlyExecute(TObject *Sender)
{
 mReadOnly->Checked = !mReadOnly->Checked;
 RichEdit1->ReadOnly = mReadOnly->Checked;
 bReadOnly->Down = mReadOnly->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mCutExecute(TObject *Sender)
{
 RichEdit1->CutToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mPasteExecute(TObject *Sender)
{
 GetClipboardText(RichEdit1->Handle);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::mBackgroundColorExecute(TObject *Sender)
{
 if(ColorDialog1->Execute())
 {
  RichEdit1->Color = ColorDialog1->Color;
  Canvas->Lock();
  RichEdit1->BorderWidth = 2;
  RichEdit1->BorderWidth = 3;
  Canvas->Unlock();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mFontColorExecute(TObject *Sender)
{
 ColorDialog1->Color = RichEdit1->Font->Color;
 if(ColorDialog1->Execute())
  RichEdit1->Font->Color = ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mOpenExecute(TObject *Sender)
{
 if(OpenDialog1->Execute())
 {
  if(FileExists(OpenDialog1->FileName))
  RichEdit1->Lines->LoadFromFile(OpenDialog1->FileName);
  Caption = FileName = ExtractFileName(OpenDialog1->FileName);
  RichEdit1->SelStart = 0;
  RichEdit1->Modified = false;
  IsOpen = true;
  PrintToolBarInformation();
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mSaveAsExecute(TObject *Sender)
{
 SaveDialog1->FileName = FileName;
 if(SaveDialog1->Execute())
 {
  RichEdit1->Lines->SaveToFile(SaveDialog1->FileName);
  Form1->RichEdit1->Modified = false;
  Caption = FileName = ExtractFileName(SaveDialog1->FileName);
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mSaveExecute(TObject *Sender)
{
 if(IsOpen) RichEdit1->Lines->SaveToFile(FileName);
 else mSaveAsExecute(Sender);
 Form1->RichEdit1->Modified = false;
 IsOpen = true;
 PrintToolBarInformation();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mNewExecute(TObject *Sender)
{
 ModifyDialog(Sender);
 RichEdit1->Clear();
 FileName = "untitled.cpp";
 Caption = FileName;
 RichEdit1->Modified = false;
 IsOpen = false;
 PrintToolBarInformation();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
 ModifyDialog(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 //---------------------------------------------------------------------------
 if(Key==VK_INSERT && !Shift.Contains(ssShift) && !Shift.Contains(ssCtrl))
                                                     InsertMode = !InsertMode;
 //---------------------------------------------------------------------------
 if(Key==VK_INSERT && Shift.Contains(ssShift))
 {
  GetClipboardText(RichEdit1->Handle);
  Key = 0;
 }
 //---------------------------------------------------------------------------
 PrintToolBarInformation();
 //------------------------------------------------------------------
 if(Key==VK_F4 && !Shift.Contains(ssAlt))
 {
  switch(Form1->WindowState)
  {
   case wsNormal: Form1->WindowState = wsMaximized; break;
   case wsMinimized:
   case wsMaximized: Form1->WindowState = wsNormal; break;
  }
 }
 //------------------------------------------------------------------
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 PrintToolBarInformation();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 PrintToolBarInformation();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 PrintToolBarInformation();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1Change(TObject *Sender)
{
 PrintToolBarInformation();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mDateAndTimeExecute(TObject *Sender)
{
 if(!RichEdit1->ReadOnly)
 {
  RichEdit1->Lines->Add("Date: " + DateToStr(Date()));
  RichEdit1->Lines->Add("Time: " + TimeToStr(Time()));
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mWebColorExecute(TObject *Sender)
{
 dWebColors->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mWebColorCustomExecute(TObject *Sender)
{
 if(ColorDialog1->Execute())
 {
  TColor color = ColorDialog1->Color;
  //-------------------------------------------------------------------------
  if(!RichEdit1->ReadOnly)
  {
   AnsiString text;
   AnsiString hex; hex.sprintf(" color = '#%x'",color);
   text = hex;
   ::SendMessage(RichEdit1->Handle, EM_REPLACESEL, 0, (LPARAM)text.c_str());
  }
 //-------------------------------------------------------------------------
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mSymbolExecute(TObject *Sender)
{
 dSymbol->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mAboutExecute(TObject *Sender)
{
 dAbout->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mFontExecute(TObject *Sender)
{
 FontDialog1->Font = RichEdit1->Font;
 if(FontDialog1->Execute())
 {
  RichEdit1->Font = FontDialog1->Font;
  Form1->RichEdit1->Perform(EM_SCROLLCARET,0,0);//normalize caret proportion
 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mFindExecute(TObject *Sender)
{
 int result = dFindText->ShowModal();
 if(result==mrOk){ SearchingText();}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mSearchAgainExecute(TObject *Sender)
{
 SearchingText();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mGotoLineExecute(TObject *Sender)
{
 dGoto->ShowModal();
}
//---------------------------------------------------------------------------

